/*
	NXBrowser.h
	Application Kit, Release 2.0
	Copyright (c) 1988, 1989, 1990, NeXT, Inc.  All rights reserved. 
*/

#import "NSControl.h"

@class NSClipView;
@class NSMatrix;
@class NSScroller;

@interface NSBrowser : NSControl
{
    id                  target;
    id                  delegate;
    id			_reserved1[3];
    SEL                 action;
    SEL                 doubleAction;
    id                  matrixClass;
    id                  cellPrototype;
    NSSize		_reserved2;
    short		_reserved4[4];
    unsigned short      pathSeparator;
    char		_reserved3[6];
    void               *_private;
}

- (void)loadColumnZero;
- (BOOL)isLoaded;

- (SEL)doubleAction;
- setDoubleAction:(SEL)aSelector;
- setMatrixClass:factoryId;
- setCellClass:factoryId;
- cellPrototype;
- setCellPrototype:aCell;
- delegate;
- setDelegate:anObject;
- (void)setReusesColumns:(BOOL)flag;
- (BOOL)reusesColumns;

- setEnabled:(BOOL)flag;

- setMultipleSelectionEnabled:(BOOL)flag;
- (BOOL)isMultipleSelectionEnabled;
- setBranchSelectionEnabled:(BOOL)flag;
- (BOOL)isBranchSelectionEnabled;
- setEmptySelectionEnabled:(BOOL)flag;
- (BOOL)isEmptySelectionEnabled;
- (void)setTakesTitleFromPreviousColumn:(BOOL)flag;
- (BOOL)takesTitleFromPreviousColumn;
- (void)setAcceptsArrowKeys:(BOOL)flag;
- (BOOL)acceptsArrowKeys;
- (void)setSendsActionOnArrowKeys:(BOOL)flag;
- (BOOL)sendsActionOnArrowKeys;

- setHorizontalScrollerEnabled:(BOOL)flag;
- (BOOL)isHorizontalScrollerEnabled;

- reuseColumns:(BOOL)flag;
- separateColumns:(BOOL)flag;
- (BOOL)columnsAreSeparated;
- getTitleFromPreviousColumn:(BOOL)flag;

- (BOOL)isTitled;
- setTitled:(BOOL)flag;
- (NSRect)titleFrameOfColumn:(int)column;
- setTitle:(NSString *)aString ofColumn:(int)column;
- (NSString *)titleOfColumn:(int)column;
- drawTitleOfColumn:(int)column inRect:(NSRect)aRect;
- (float)titleHeight;
- setPathSeparator:(NSString *)charaters;
- setPath:(NSString *)path;
- (NSString *)pathToColumn:(int)column;

- displayColumn:(int)column;
- reloadColumn:(int)column;
- validateVisibleColumns;
- displayAllColumns;

- scrollColumnsRightBy:(int)shiftAmount;
- scrollColumnsLeftBy:(int)shiftAmount;
- scrollColumnToVisible:(int)column;
- scrollUpOrDown:sender;
- reflectScroll:clipView;
- scrollViaScroller:sender;
- updateScroller;

- setLastColumn:(int)column;
- addColumn;

- setMinColumnWidth:(float)columnWidth;
- (float)minColumnWidth;
- setMaxVisibleColumns:(int)columnCount;
- (int)maxVisibleColumns;
- (int)numVisibleColumns;
- (int)firstVisibleColumn;
- (int)lastVisibleColumn;
- (int)lastColumn;
- (int)selectedColumn;
- selectedCell;
- getSelectedCells:(List *)aList;
- (int)columnOf:matrix;
- matrixInColumn:(int)column;
- getLoadedCellAtRow:(int)row inColumn:(int)col;
- selectAll:sender;

- (NSRect)frameOfColumn:(int)column;
- (NSRect)frameOfInsideColumn:(int)column;

- tile;

- drawRect:(NSRect)rect;
- mouseDown:(NSEvent *)theEvent;
- setFrameSize:(NSSize)_newSize;
- sizeToFit;

- acceptArrowKeys:(BOOL)acceptFlag andSendActionMessages:(BOOL)sendFlag;
- keyDown:(NSEvent *)theEvent;
- (BOOL)acceptsFirstResponder;

- doClick:sender;
- doDoubleClick:sender;
- sendAction;

@end

@interface NSObject(BrowserDelegate)
- (int)browser:sender numberOfRowsInColumn:(int)column;
- (void)browser:sender createRowsForColumn:(int)column inMatrix:matrix;
- browser:sender willDisplayCell:cell atRow:(int)row column:(int)column;
- (NSString *)browser:sender titleOfColumn:(int)column;
- (BOOL)browser:sender selectCellWithString:(NSString *)title inColumn:(int)column;
- (BOOL)browser:sender isColumnValid:(int)column;
- browserWillScroll:sender;
- browserDidScroll:sender;
@end
