/*
	SliderCell.h
	Application Kit, Release 2.0
	Copyright (c) 1988, 1989, 1990, NeXT, Inc.  All rights reserved. 
*/

#import "NSActionCell.h"

@interface NSSliderCell : NSActionCell
{
    void *              _scPrivate;
    int                 _scPrivate1;
    int                 _scPrivate2;
    double              value;
    double              maxValue;
    double              minValue;
    NSRect              trackRect;
}


+ (BOOL)prefersTrackingUntilMouseUp;

- (double)minValue;
- setMinValue:(double)aDouble;
- (double)maxValue;
- setMaxValue:(double)aDouble;
- setAltIncrementValue:(double)incValue;
- (double)altIncrementValue;
- (int)isVertical;
- (NSString *)stringValue;
- setStringValue:(NSString *)aString;
- (int)intValue;
- setIntValue:(int)anInt;
- (float)floatValue;
- setFloatValue:(float)aFloat;
- (double)doubleValue;
- setDoubleValue:(double)aDouble;
- setContinuous:(BOOL)flag;
- (BOOL)isContinuous;
- (BOOL)isOpaque;
- (NSSize)cellSizeForBounds:(NSRect)aRect;
- setTitleGray:(float)grayVal;
- (float)titleGray;
- setTitleColor:(NSColor *)newColor;
- (NSColor *)titleColor;
- setTitleFont:fontObj;
- titleFont;
- (NSString *)title;
- setTitle:(NSString *)aString;
- setTitleCell:aCell;
- titleCell;
- setEnabled:(BOOL)flag;
- setKnobThickness:(float)aFloat;
- (float)knobThickness;
- setImage:backgroundImage;
- image;
- (NSRect)knobRectFlipped:(BOOL)flipped;
- drawKnob:(NSRect)knobRect;
- drawKnob;
- drawBarInside:(NSRect)aRect flipped:(BOOL)flipped;
- drawWithFrame:(NSRect)cellFrame inView:controlView;
- drawInteriorWithFrame:(NSRect)cellFrame inView:controlView;
- (BOOL)startTrackingAt:(NSPoint)startPoint inView:controlView;
- (BOOL)continueTracking:(NSPoint)lastPoint at:(NSPoint)currentPoint inView:controlView;
- stopTracking:(NSPoint)lastPoint at:(NSPoint)stopPoint inView:controlView mouseIsUp:(BOOL)flag;
- (BOOL)trackMouse:(NSEvent *)theEvent inRect:(NSRect)cellFrame ofView:controlView untilMouseUp:(BOOL)untilMouseUp;

@end
